#### User-contributed documentation and links (![](/_res/l.png) icon) to third party docs ####

[Infrequently Asked Questions](misc/iaq.adoc)

`common-tasks`
- [how to copy files (and sparse files) from a VM to dom0](common-tasks/copying-files-to-dom0.md)
- [how to open URLs in another VM](common-tasks/opening-urls-in-vms.md)

`configuration`
- ![](/_res/l.png) [use Qubes 3.2 OS as a network server](https://github.com/Rudd-O/qubes-network-server)
- ![](/_res/l.png) [use Qubes OS as a smartTV](https://github.com/Aekez/QubesTV)
- ![](/_res/l.png) [VM hardening (fend off malware at VM startup)](https://github.com/tasket/Qubes-VM-hardening)
- ![](/_res/l.png) [VPN configuration](https://github.com/tasket/Qubes-vpn-support)
- [Run wireguard on server and use as VPN for Qubes](wireguard/README.md)
- [Make an HTTP Filtering Proxy](configuration/http-proxy.md)
- ![](/_res/l.png) [Ansible Qubes](https://github.com/Rudd-O/ansible-qubes) (see Rudd-O's [other repos](https://github.com/Rudd-O?tab=repositories) as well)
- [shrink VM volumes](configuration/shrink-volumes.md)
- ![](/_res/l.png) [script to create Windows qubes automatically](https://github.com/elliotkillick/qvm-create-windows-qube)
- [Manage Qubes via dmenu](configuration/qmenu.md)
- [Pihole qube (old post, but also work on QubesOS 4.0)](https://blog.tufarolo.eu/how-to-configure-pihole-in-qubesos-proxyvm/)
- [Newer Pihole qube, with cloudflared or NextDNS servers](https://github.com/92VV3M42d3v8/PiHole/blob/master/PiHole%20Cloudflared)

`coreboot`
- [install coreboot on a Thinkpad x230](coreboot/x230.md)

`customization`
- [change DPI scaling in dom0 and VMs](customization/dpi-scaling.md)
- [setup mirage firewall](customization/mirage-firewall.md)
- [windows 7 gaming HVM with GPU passthrough](customization/windows-gaming-hvm.md)
- [SecBrowser "security-enhanced" browser](customization/secbrowser.md)  
- [Choose deafult terminal settings for a TemplateVM](customization/terminal-defaults.md)  
- [Screenlockers](customization/screenlockers.md)  

`hardware`
- [tips on choosing the right hardware](hardware/hardware-selection.md)

`localization`
- [how to use multiple keyboard layouts](localization/keyboard-multiple-layouts.md)

`misc`
- ![](/_res/l.png) [Qubes 3.2 cheat sheet](https://github.com/Jeeppler/qubes-cheatsheet)
- [infrequently asked questions](misc/iaq.adoc)

`system`
- [understanding and fixing issues with time/clock](system/clock-time.md)
- [restoring 3.2 templates/standalones to 4.0](system/restore-3.2.md)
- [connect to a VM console](system/vm-console.md)
- [display reminders to make regular backups](system/backup-reminders.md)
- [mount a VM's private storage volume in another VM](system/vm-image.md)

`user-setups`
- [examples of user setups](user-setups/) (templates and VMs used, productivity tips, customizations, ...)
