User setups
===========

This folder contains setups used by Qubes users, like:

- how many templates they use, how they customized them
- which VMs are networked, firewalled, or without network
- what kind of data is allowed in specific VMs
- how data flows between VMs
- productivity tricks, what window manager they use (e.g i3), ...
- ...

Things to keep in mind:

- There is **no guarantee** that a given setup is "secure"
- Obviously there's no one-size-fits-all setup; the idea here is to give ideas to new Qubes OS users. Long time users may also find a thing or two interesting.
- Qubes OS is designed so that the biggest factor in maintaining security is always how you divide up your data and workflows between VMs. The choice of template (fedora, debian, ...) isn't as critical.
- More VMs = better data compartmentalization, but increased CPU/RAM usage.
- More TemplateVMs = better fit (eg. minimal template for sys-firewall, "heavy" non-networked template for multimedia, ...), but increases disk usage + bandwidth for downloading updates.

Related posts:
- https://blog.invisiblethings.org/2011/03/13/partitioning-my-digital-life-into.html
- https://groups.google.com/forum/#!topic/qubes-users/hvGX_Q7gv2o

